/*
 * This software is Copyright (c) 2012 Sayantan Datta <std2048 at gmail dot com>
 * and it is hereby released to the general public under the following terms:
 * Redistribution and use in source and binary forms, with or without modification, are permitted.
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
void
writeProgramBin(  size_t binary_size, char *binary,
                  char *filename )
{
    FILE *output = NULL;
    printf( "Writing out binary kernel to %s\n", filename );
    output = fopen( filename, "wb" );
    fwrite( binary, sizeof(char), binary_size, output );
    if( output == NULL )
	{
	  fprintf( stderr, "Unable to open %s for write. Exiting.\n",
                   filename );
          exit( -1 );
        }
    fclose( output );
}


int main(int argc, char *argv[] )
{
  
 ///There might be some unused variables 
    unsigned int i = 0,j=0;
    FILE * input = NULL;
    size_t size1 = 0;
    size_t size2 = 0;
    size_t size3 = 0;
    size_t size4 = 0;
    unsigned char * binary1 = NULL;
    unsigned char * binary2 = NULL;
    unsigned char * binary3 = NULL;
    unsigned char * binary4 = NULL;
    char *filename;
    size_t size;
    int offset=0x00000303 , newBinSize = 0x0005e34c ;
    
     if ( argc != 4 ) {printf("Error:getInnerElf:Too few arguments\n"); return 1; }
     else {   
	filename = argv[1] ;
	offset   = atoi(argv[2]);
	newBinSize = atoi(argv[3]);
     }   
	printf( "Reading in binary kernel from %s\n", filename );
        input = fopen( filename, "rb" );
        if( input == NULL )
        {
            fprintf( stderr, "Unable to open %s for reading.\n", filename );
            
        }
        fseek( input, 0L, SEEK_END );    
        size1 = ftell( input );
        rewind( input );
        binary1 = (char *)malloc( size1 );
        fread( binary1, sizeof(char), size1, input );
        fclose( input );
	
	
	unsigned char* newbin = (unsigned char*)malloc(newBinSize);
	
	for(i=offset;i<(offset + newBinSize);i++)
	{
	    newbin[ctr++] = binary1[i] ;
	}
	char outFileName[100];
	sprintf(outFileName,"%s.text",filename);
	writeProgramBin(newBinSize,newbin,outFileName);

        return 0;
}


 
